import turtle as t
import math
import random

def téglalap(a, b):
    for i in range(2):
        t.forward(a)
        t.right(90)
        t.forward(b)
        t.right(90)
        
def homok():
    t.color("#FFD897")
    t.fillcolor("#FFD897")
    t.down()
    t.begin_fill()
    téglalap(796, 399)
    t.end_fill()
    
def tenger():
    t.color("#00B0F9")
    t.fillcolor("#00B0F9")
    t.down()
    t.begin_fill()
    téglalap(796, 100)
    t.end_fill()

def paralelogramma(a, b, sz1, sz2):
    t.color(sz1)
    t.fillcolor(sz2)
    t.down()
    t.begin_fill()
    for i in range(2):
        t.forward(a)
        t.right(120)
        t.forward(b)
        t.right(60)
    t.end_fill()
    t.up()

def háromszög(méret):
    t.begin_fill()
    for i in range(3):
        t.forward(méret)
        t.right(120)
    t.end_fill()

def minta(méret, db, sz1, sz2):
    t.color(sz1)
    t.fillcolor(sz2)
    for i in range(db):
        t.fillcolor(sz1)
        háromszög(méret)
        t.right(60)
        t.fillcolor(sz2)
        háromszög(méret)
        t.left(60)
        t.right(120)
        t.forward(méret)
        t.left(120)
    t.right(120)
    t.back(méret*db)
    t.left(120)

def rojt(a, b):
    t.down()
    for i in range(int(b/4)):
        t.forward(a)
        t.back(a)
        t.right(120)
        t.forward(4)
        t.left(120)
    t.forward(a)
    t.back(a)

def törölköző(méret, sz1, sz2):
    t.color(sz1)
    t.fillcolor(sz2)
    rojt(méret/10, méret)
    t.right(180)
    for i in range(7):
        paralelogramma(int(méret/10), méret, sz1, sz2)
        t.up()
        t.forward(int(méret/10))
        t.down()
        minta(int(méret/10), 10, sz1, sz2)
        t.up()
        t.forward(int(méret/10))
        t.down()
    paralelogramma(int(méret/10), méret, sz1, sz2)
    t.up()
    t.forward(méret/10)
    t.down()
    rojt(int(méret/10), méret)
    t.right(180)
    t.forward(méret*1.5)

def napernyő(méret, sz1, sz2):
    t.down()
    t.color("black")
    t.width(méret/40)
    t.forward(méret)
    t.width(1)
    t.forward(méret/2)
    t.left(90)
    
    t.begin_fill()
    t.fillcolor(sz2)
    t.circle(méret/2, -90)
    t.circle(méret/8,180)
    t.right(180)
    t.forward(méret/4)
    t.circle(méret/4, 90)
    t.left(90)
    t.end_fill()
      
    t.begin_fill()
    t.fillcolor(sz1)
    t.forward(méret/2)
    t.circle(méret/8, -180)
    t.forward(méret/4)
    t.circle(méret/4, 90)
    t.end_fill()
    
    t.begin_fill()
    t.fillcolor(sz2)
    t.circle(méret/4, 90)
    t.forward(méret/4)
    t.circle(méret/8, -180)
    t.forward(méret/2)
    t.end_fill()

    t.begin_fill()
    t.fillcolor(sz1)
    t.left(90)
    t.circle(méret/2,90)
    t.circle(méret/8, -180)
    t.forward(méret/4)
    t.right(180)
    t.circle(méret/4, -90)
    t.end_fill()
    
    t.up()
    t.right(90)
    t.back(méret*1.5)
    

def levél(méret):
    t.width(1)
    t.down()
    t.color("#17885D")
    t.fillcolor("#17885D")
    t.right(30)
    t.begin_fill()
    t.circle(méret/2,60)
    t.left(120)
    t.circle(méret/2,60)
    t.left(120)
    t.end_fill()
    t.left(30)
    t.up()

def pálmaágbal(méret, szint):
    if (szint==1):
        levél(méret)
    else:
        pálmaágbal(méret, szint-1)
        t.down()
        t.back(méret/5)
        t.left(5)
        t.right(30)
        levél(méret)
        t.left(60)
        levél(méret)
        t.right(30)

def pálmaágjobb(méret, szint):
    if (szint==1):
        levél(méret)
    else:
        pálmaágjobb(méret, szint-1)
        t.down()
        t.back(méret/5)
        t.right(5)
        t.right(30)
        levél(méret)
        t.left(60)
        levél(méret)
        t.right(30)

def pálmaág(méret, szint, irány):
    if (irány=="jobb"):
        for i in range(szint-1):
            t.left(5)
            t.forward(méret/5)
        pálmaágjobb(méret, szint)
    else:
        for i in range(szint-1):
            t.right(5)
            t.forward(méret/5)
        pálmaágbal(méret, szint)

def trapéz(méret):
    t.down()
    t.begin_fill()
    t.left(30)
    t.forward(méret)
    t.right(120)
    t.forward(méret*2)
    t.right(120)
    t.forward(méret)
    t.right(60)
    t.forward(méret)
    t.right(90)
    t.end_fill()
    t.up()

def pálmaszár(méret, magasság):
    t.width(2)
    t.color("#B5865C")
    t.fillcolor("#4A2700")
    for i in range(magasság):
        trapéz(méret)
        t.up()
        t.forward(méret*math.sqrt(3)/2)
        t.down()

def pálmafa(méret):
    t.down()
    pálmaszár(méret, 10)
    t.right(90)
    t.forward(méret/2)
    t.left(90)
    for i in range(3):
        pálmaág(méret*3,10,"bal")
        t.right(50)
    t.left(150)
    for i in range(3):
        pálmaág(méret*3,10,"jobb")
        t.left(50)
    t.right(150)
    t.up()
    t.right(90)
    t.back(méret/2)
    t.left(90)
    t.back(méret*math.sqrt(3)*5)    

def rajz():
    t.tracer(False)
    t.clear()
    t.up()
    t.goto(-398, 249)
    homok()
    t.goto(-398, -150)
    tenger()
    t.up()
    t.left(90)
    for i in range(6):
        xPoz=-315+i*125
        yPoz=random.choice([50, 70, 90])
        t.goto(xPoz,yPoz)
        pálmafa(random.choice([6,8,10]))
    t.goto(-340, -70)
    for i in range(6):
        color=random.choice(["#FF7F27", "#FF0000", "#0000FF"])
        fillcolor=random.choice(["#FFFF00", "#000066", "#00FF00"])
        t.left(20)
        napernyő(60, color, fillcolor)
        t.right(20)
        t.left(60)
        törölköző(60, color, fillcolor)
        t.right(60)
        t.up()
        t.right(90)
        t.forward(120)
        t.left(90)
        t.down()
    t.update()
    t.done()

rajz()
